unit mn_abstr;

interface

type
  kVsebina=^vsebina;
  vsebina=object {objekt, v kakrsnih je shranjena vsebina mnozice}
    constructor vsKons; {zaradi virtualnih metod}
    destructor vsDest; virtual; {zaradi virtualnih metod, morebitnih razsiritev v dedicih}
    function jeEnak (vs: kVsebina): boolean; virtual; {primerja sebe z objektom, na katerega kaze vs}
    function prepisi: kVsebina; virtual; {vrne kopijo sebe}
  end;
  kMnozica=^mnozica;
  mnozica=object {objekt, ki hrani mnozico; vecina funkcij ob uspehu vrnej true, sicer false; parameter iter doloca
                 iterativnost/rekurzivnost}
    tip: (poljeEl, kurzorji, kazalci); {tip mnozice}
    constructor mnKons; {zaradi virtualnih metod}
    destructor mnDest; virtual; {sprosti spomin, ki ga je zasedala mnozica}
    procedure naredi; virtual; {inicializira}
    procedure izvoziU (mn: kMnozica; preveri, iter: boolean); virtual; {v mnozico, na katero kaze mn, doda svoje elemente
                                                                       (za unijo)}
    procedure izvoziP (mn, drugaMn: kMnozica; iter: boolean); virtual; {v mnozico, na katero kaze mn, doda tiste svoje
                                                                       elemente, ki jih ne vsebuje drugaMn}
    function dodaj (vs: kVsebina; preveri, iter: boolean): boolean; virtual; {doda element, na katerega kaze vs; iter se nanasa
                                                                             na metodo pripadnost, ki jo ta metoda klice}
    function brisi (vs: kVsebina): boolean; virtual; {brise element enak onemu, na katerega kaze vs}
    function pripada (vs: kVsebina; iter: boolean): boolean; virtual; {ugotovi, ce je v mnozici element enak onemu, na katerega
                                                                      kaze vs}
    function unija (mn1, mn2: kMnozica; iter: boolean): boolean; virtual; {vase vpise unijo mnozic, na keteri kazeta mn1, mn2}
    function presek (mn1, mn2: kMnozica; iter: boolean): boolean; virtual; {vase vpise presek mnozic, na keteri kazeta mn1,
                                                                           mn2}
  end;

implementation {ta objekt je abstrakten - implementacija je zato prazna}

constructor vsebina.vsKons; begin end;
destructor vsebina.vsDest; begin end;
function vsebina.jeEnak; begin end;
function vsebina.prepisi; begin end;

constructor mnozica.mnKons; begin end;
destructor mnozica.mnDest; begin end;
procedure mnozica.naredi; begin end;
procedure mnozica.izvoziU; begin end;
procedure mnozica.izvoziP; begin end;
function mnozica.dodaj; begin end;
function mnozica.brisi; begin end;
function mnozica.pripada; begin end;
function mnozica.unija; begin end;
function mnozica.presek; begin end;

end.